% multigrid_v_cycle
% 

clc; clear all; close all;

k = 10;
N = 2^k-1;

x_full = (linspace(0,1,N+2))'; % add the boundary points

x = x_full(2:end-1); h = x(2) - x(1);

% Homogeneous Dirichlet b.c. => equations only at the inner points
% and the resulting matrix is symmetric, positive definite
[A,L,R,D] = prepare_matrices(h,N);
u = sin(10*pi*x);
f = A*u;

u0 = ones(N,1);
maxit = 10;
toler = 1e-10;

res = zeros(maxit+1,1);
res(1) = norm(A*u0-f);

u = u0;
for ctr=1:maxit
    u = v_cycle(u,f);
    r = A*u - f;
    
    nr = norm(r)/norm(f);
    res(ctr) = nr;
    if nr<toler
        disp(['V Cycle converged at ',num2str(ctr),'-th iteration']);
        break
    end
end


semilogy((1:maxit+1),res,'*-');




